auth.py
from flask import Blueprint, render_template, redirect, url_for, request, flash
from werkzeug.security import generate_password_hash, check_password_hash
from app import app, db
from models import Utilisateur , find_pseudo, get_new_id, find_by_id
from flask_login import login_user, login_required, logout_user, current_user
import datetime
auth = Blueprint('auth', __name__)

@auth.route("/login/")
def login():
    return render_template(
        "connexion.html",
        title = "Login"
    )

@auth.route("/logout")
@login_required
def logout():
    logout_user()
    return redirect(url_for("home"))

@auth.route("/login/", methods=['POST'])
def login_post():
    pseudo = request.form.get('pseudo')
    password = request.form.get('mdp')
    user = find_pseudo(pseudo)
    # check if the user actually exists
    # take the user-supplied password, hash it, and compare it to the hashed password in the database
    if not user or not check_password_hash(user.mdp, password):
        flash('Vérifiez vos identifiants et réessayez')
        return redirect(url_for('auth.login')) # if the user doesn't exist or password is wrong, reload the page
    # if the above check passes, then we know the user has the right credentials
    login_user(user)
    return redirect(url_for("homeConnected"))


@auth.route("/register/")
def register():
    return render_template(
        "register.html",
        title = "Register"
    )

@auth.route("/register", methods=['POST'])
def register_post():
    pseudo = request.form.get('pseudo')
    user = find_pseudo(pseudo)
    if user:
        flash("Votre pseudo est déjà utilisé.")
        return redirect(url_for("auth.register"))

    mdp = request.form.get('mdp')
    id = get_new_id()
    prenom = request.form.get('prenom')
    nom = request.form.get('nom')
    extractDate = request.form.get('dateNaissance')
    annee = int(extractDate[0:4])
    mois = int(extractDate[5:7])
    jour = int(extractDate[8:10])
    dateNaissance = datetime.date(annee,mois,jour)
    sexe = request.form.get('sexe')
    urlImg = request.form.get('urlImg')
    dateInscription = datetime.date.today()
    new_user = Utilisateur(id = id,pseudo = pseudo, prenom=prenom, nom=nom, urlImage=urlImg, dateNaiss=dateNaissance, sexe=sexe, mdp=generate_password_hash(mdp, method='sha256'), dateInscription = dateInscription)
    db.session.add(new_user)
    db.session.commit()
    return redirect(url_for("auth.login"))

@auth.route("/connected/profil/modif/")
def modifProfil():
    return render_template(
        "modifProfil.html",
        title = "Profil",
        nom = current_user.nom,
        prenom = current_user.prenom,
        pseudo = current_user.pseudo,
        dateNaiss = current_user.dateNaiss,
        sexe = current_user.sexe,
        mdp = current_user.mdp,
        dateInscription = current_user.dateInscription,
        urlImg = current_user.urlImage,
    )

@auth.route("/connected/profil/modif", methods=['POST'])
def modifProfil_post():
    user = find_by_id(current_user.id)
    pseudo = request.form.get('pseudo')
    tempUser = find_pseudo(pseudo)
    if tempUser:
        if tempUser.pseudo != current_user.pseudo:
            flash("Votre pseudo est déjà utilisé.")
            return redirect(url_for("auth.modifProfil"))

    user.pseudo = pseudo
    if request.form.get('mdp'):
        user.mdp = generate_password_hash(request.form.get('mdp'),method='sha256')
    user.prenom = request.form.get('prenom')
    user.nom = request.form.get('nom')
    extractDate = request.form.get('dateNaissance')
    annee = int(extractDate[0:4])
    mois = int(extractDate[5:7])
    jour = int(extractDate[8:10])
    user.dateNaissance = datetime.date(annee,mois,jour)
    user.sexe = request.form.get('sexe')
    user.urlImage = request.form.get('urlImg')
    db.session.commit()
    return redirect(url_for("profil"))

templates/components/album.html
<li class="nav-item d-flex align-content-center"><button
    class="btn btn-lg border rounded border-secondary"
    data-bs-hover-animate="pulse" type="button"
    style="margin-bottom: 1em;margin-right: 1.5em;margin-top: 1em;color: var(--gray);"
    onclick="window.location.href = '/connected/playlist/';">Playlists</button>
</li>
<li class="nav-item d-flex"><button
    class="btn btn-lg border rounded d-flex align-items-center"
    data-bs-hover-animate="pulse" type="button"
    style="margin-bottom: 1em;min-width: 118.45px;margin-right: 1.5em;margin-top: 1em;color: white;;"
    onclick="window.location.href = '/connected/album/';">Albums</button>
</li>
<li class="nav-item d-flex"><button
    class="btn btn-lg border rounded border-secondary"
    data-bs-hover-animate="pulse" type="button"
    style="margin-bottom: 1em;min-width: 118.45px;margin-right: 1.5em;margin-top: 1em;color: var(--gray);"
    onclick="window.location.href = '/connected/artiste/';">Artistes</button>
</li>

templates/components/artiste.html
<li class="nav-item d-flex align-content-center"><button
    class="btn btn-lg border rounded border-secondary"
    data-bs-hover-animate="pulse" type="button"
    style="margin-bottom: 1em;margin-right: 1.5em;margin-top: 1em;color: var(--gray);"
    onclick="window.location.href = '/connected/playlist/';">Playlists</button>
</li>
<li class="nav-item d-flex"><button
    class="btn btn-lg border rounded border-secondary"
    data-bs-hover-animate="pulse" type="button"
    style="margin-bottom: 1em;min-width: 118.45px;margin-right: 1.5em;margin-top: 1em;color: var(--gray);"
    onclick="window.location.href = '/connected/album/';">Albums</button>
</li>
<li class="nav-item d-flex"><button
    class="btn btn-lg border rounded d-flex align-items-center "
    data-bs-hover-animate="pulse" type="button"
    style="margin-bottom: 1em;min-width: 118.45px;margin-right: 1.5em;margin-top: 1em;color: white;"
    onclick="window.location.href = '/connected/artiste/';">Artistes</button>
</li>

templates/components/navbar.html
<div class="row d-flex">
    <div class="col d-flex">
        <nav class="navbar navbar-light navbar-expand-md d-flex flex-grow-1">
            <div class="container-fluid">
                <div class="collapse navbar-collapse d-flex justify-content-between align-items-center"
                    id="navcol-1">
                    <ul class="nav navbar-nav d-flex" id="nav">
                        <li>
                            <a class="btn btn-dark btn-lg" role="button" id="menu-toggle"
                                href="#menu-toggle">
                                <i class="fa fa-bars"></i>
                            </a>
                        </li>
                        {% if selection=="playlist" %}
                        {% include "components/playlist.html" %}
                        {% elif selection=="album" %}
                        {% include "components/album.html" %}
                        {% elif selection=="artiste" %}
                        {% include "components/artiste.html" %}
                        {% endif %}
                        <li class="nav-item d-flex"></li>
                    </ul>
                    <ul class="nav navbar-nav d-flex">
                        <button
                            class="btn dropdown-toggle bg-white border rounded-pill d-flex align-items-center flex-nowrap"
                            type="button" id="dropdownMenuButton" data-toggle="dropdown"
                            aria-haspopup="true" aria-expanded="false">
                            <i class="fa fa-user" id="pseudo"></i> {{pseudo}}
                        </button>
                        <div class="dropdown-menu" aria-labelledby="dropdownMenuButton">
                            <a class="dropdown-item" href="/connected/profil">Mon compte</a>
                            <a class="dropdown-item" href="{{url_for('auth.logout')}}">Déconnexion</a>
                        </div>
                    </ul>
                </div>
            </div>
        </nav>
    </div>
</div>

templates/components/playlist.html
<li class="nav-item d-flex align-content-center"><button
    class="btn btn-lg border rounded d-flex align-items-center"
    data-bs-hover-animate="pulse" type="button"
    style="margin-bottom: 1em;margin-right: 1.5em;margin-top: 1em;color: white;;"
    onclick="window.location.href = '/connected/playlist/';">Playlists</button>
</li>
<li class="nav-item d-flex"><button
    class="btn btn-lg border rounded border-secondary"
    data-bs-hover-animate="pulse" type="button"
    style="margin-bottom: 1em;min-width: 118.45px;margin-right: 1.5em;margin-top: 1em;color: var(--gray);"
    onclick="window.location.href = '/connected/album/';">Albums</button>
</li>
<li class="nav-item d-flex"><button
    class="btn btn-lg border rounded border-secondary"
    data-bs-hover-animate="pulse" type="button"
    style="margin-bottom: 1em;min-width: 118.45px;margin-right: 1.5em;margin-top: 1em;color: var(--gray);"
    onclick="window.location.href = '/connected/artiste/';">Artistes</button>
</li>

templates/components/sidebar.html
<aside id="sidebar-wrapper" style="font-size: 1.2em;opacity: 1;">
    <ul class="sidebar-nav">
        <li class="sidebar-brand" style="margin-bottom: 10%;">
            <a href="/connected/" style="color: white;font-size: 2.8em;">
                <img src="{{ url_for('static', filename='img/logo.png') }}" alt="Logo du site Hitflix">
            </a>
        </li>
        <li><a href="/connected/"><i class="fa fa-home" style="margin-right: 4%;"></i>Accueil</a> </li>
        <li><a href="/connected/recherche/"><i class="fa fa-search" style="margin-right: 4%;"></i>Rechercher</a></li>
        <li><a href="/connected/playlist"><i class="fa fa-music" style="margin-right: 4%;"></i>Ma Musique</a></li>
    </ul>
</aside>